################################################################################
# This is the Sage equivalent of the Java code in Listing 3.1 in Section 3.4.  #
# It uses the Monte Carlo method to approximate the double integral of         #
# f(x,y) = 8x + 6y over the rectangle [0,1]x[0,2].                             #
# The initial number of random points used is N=10. To use more points just    #
# change the parameter N in the montecarlo(N) function, e.g. montecarlo(100)   #
# or montecarlo(10000).                                                        #
################################################################################
x = float(0)        # Random x coordinate
y = float(0)        # Random y coordinate
f = float(0)        # Value of f at a random point
mf = float(0)       # Mean of the values of f
mf2 = float(0)      # Mean of the values of f^2
vol = float(1*2)    # Volume of the rectangle
def montecarlo(N):
    global x, y, f, mf, mf2, vol
    N = int(N)
    for i in xrange(N):
        x = random()
        y = 2*random()
        f = 8*x + 6*y
        mf = mf + f
        mf2 = mf2 + f*f
    mf = mf/N
    mf2 = mf2/N
    print "N = %d: %.15f +/- %.15f" % (N,vol*mf,vol*math.sqrt((mf2 - mf^2)/N))
# Use 10 random points in the rectangle
montecarlo(10)
